function Редактор(события, имяОбласти)
{
    this.создать = function()
    {
        this.установитьAce();
        this.улавливатьЗавершениеРедактирования();
        события.подписать(this);
    };

    this.обработатьСобытие = function(событие)
    {
        if (событие == "завершили редактирование")
        {
            this.проверитьКорректностьКода();
        }
        else if (событие == "код корректен")
        {
            this.преобразоватьВZ64();
        }
    };

    this.преобразоватьВZ64 = function()
    {
        var содержимое = this.ace.session.getValue();
        var z64 = this.вZ64(содержимое);
/**/console.debug("ИГР z64:", z64);
/**/console.debug("ИГР обратно:", this.изZ64(z64));
    };

    this.установитьAce = function()
    {
         var область = document.getElementById(имяОбласти);
         this.ace = window.ace.edit(имяОбласти);
         this.ace.session.setMode("ace/mode/javascript");
    }

    this.улавливатьЗавершениеРедактирования = function()
    {
        var тут = this;
        this.ace.session.on("change", function(дельта) {
            const билет = тут.uuid();
            тут.билет = билет;
            setTimeout(
                function()
                {
                    if (билет == тут.билет)
                    {
                        события.уведомить("завершили редактирование");
                    }
                },
                1000
            );
        });
    };

    this.проверитьКорректностьКода = function()
    {
        try
        {
            eval(this.ace.session.getValue());
            события.уведомить("код корректен");
        }
        catch (ошибка)
        {
            события.уведомить("код некорректен");
        }
    };

    this.в64 = function(строка)
    {
        var байты = new TextEncoder("utf-8").encode(строка);
        return base64js.fromByteArray(байты);
    };

    this.вZ64 = function(строка)
    {
        var байты = new TextEncoder("utf-8").encode(строка);
        var сжатиеZip = window.pako.deflate(байты, {to: 'string'});
        return this.в64(сжатиеZip);
    };

    this.из64 = function(шифр)
    {
        var байты = base64js.toByteArray(шифр);
        return new TextDecoder("utf-8").decode(байты);
    };

    this.изZ64 = function(шифр)
    {
        var сжатиеZip = this.из64(шифр);
        var байты = window.pako.inflate(сжатиеZip)
        return new TextDecoder("utf-8").decode(байты);
    };

    this.uuid = function()
    {
        // https://stackoverflow.com/a/2117523
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(
            /[xy]/g,
            function(c)
            {
                var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            }
        );
    };

    // Конструктор.
    this.создать();
}
